abuild.in 55.7 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# abuild - build apk packages (light version of makepkg)
4
# Copyright (c) 2008-2015 Natanael Copa <ncopa@alpinelinux.org>
5
# Copyright (c) 2016 Timo Teräs <timo.teras@iki.fi>
Natanael Copa's avatar
Natanael Copa committed
6 7 8 9
#
# Distributed under GPL-2
#

10
program_version=@VERSION@
Natanael Copa's avatar
Natanael Copa committed
11
sysconfdir=@sysconfdir@
Natanael Copa's avatar
Natanael Copa committed
12
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
13

14
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
15

16 17 18 19 20 21
if ! [ -f "$datadir/functions.sh" ]; then
	echo "$datadir/functions.sh: not found" >&2
	exit 1
fi
. "$datadir/functions.sh"

Natanael Copa's avatar
Natanael Copa committed
22
# defaults
23
BUILD_BASE="build-base"
24

25 26 27 28 29
: ${FAKEROOT:="fakeroot"}
: ${SUDO_APK:="abuild-apk"}
: ${APK:="apk"}
: ${ADDUSER:="abuild-adduser"}
: ${ADDGROUP:="abuild-addgroup"}
30

31
apk_opt_wait="--wait 30"
32

Kaarle Ritvanen's avatar
Kaarle Ritvanen committed
33 34
umask 022

35 36 37 38 39
# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
40

41
# we override the default msg, warning and error as we want the pkgname
Natanael Copa's avatar
Natanael Copa committed
42
msg() {
43
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
44 45 46
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
47 48 49
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
50 51 52 53
warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
54 55 56
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
57 58 59 60
error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
61
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
62
	logcmd "ERROR: $pkgname: $1"
63 64
}

65 66 67 68
cross_compiling() {
	test "$CBUILD" != "$CHOST" -a -n "$CBUILDROOT"
}

Linux User's avatar
Linux User committed
69
cleanup() {
70
	local i=
71
	[ -z "$subpkgdir" ] && set_xterm_title ""
72 73 74
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
75 76 77 78 79 80 81
	for i; do
		case $i in
		pkgdir) msg "Cleaning up pkgdir"; rm -rf "$pkgbasedir";;
		srcdir) msg "Cleaning up srcdir"; rm -rf "$srcdir";;
		deps)
			if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
				msg "Uninstalling dependencies..."
82
				$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
83
				if cross_compiling; then
84
					$SUDO_APK del --root "$CBUILDROOT" \
85
						--no-scripts --quiet $apk_opt_wait \
86 87
						$uninstall_after
				fi
88 89 90 91
			fi
			;;
		esac
	done
Linux User's avatar
Linux User committed
92 93
}

Natanael Copa's avatar
Natanael Copa committed
94
die() {
Linux User's avatar
Linux User committed
95
	error "$@"
96
	cleanup $ERROR_CLEANUP
Natanael Copa's avatar
Natanael Copa committed
97 98 99
	exit 1
}

100 101 102 103
spell_error() {
	die "APKBUILD contains '$1'. It should be '$2'"
}

104
# check if apkbuild is basicly sane
105
default_sanitycheck() {
106
	local i= j= suggestion=
107
	msg "Checking sanity of $APKBUILD..."
108 109 110
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
111
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
112
		$APK version --check --quiet "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
113 114
			die "$pkgver is not a valid version"
	fi
115
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
116 117 118
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
Natanael Copa's avatar
Natanael Copa committed
119 120 121
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
122
	is_function package || warning "Missing package() function in APKBUILD"
123

Natanael Copa's avatar
Natanael Copa committed
124 125
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
126 127
		die "replaces_priority must be a number"
	fi
128 129 130
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
131
		-*) die "${i%%:*} is not a valid package name";;
132 133 134
		esac
	done

Natanael Copa's avatar
Natanael Copa committed
135
	for i in $install; do
136
		local n=${i%.*}
137
		local suff=${i##*.}
138 139 140 141 142
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
143
			die "$i: install script does not match pkgname or any subpackage"
144
		fi
145
		[ -e "$startdir/$i" ] || die "install script $i is missing"
146 147 148 149 150 151
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
152
	done
153

154 155 156
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
157
		[ "$f" = "$i" ] && die "$f: triggers must contain '='"
158 159 160 161
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
162

163 164
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
165 166
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
167 168 169 170
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
Natanael Copa's avatar
Natanael Copa committed
171
			case "$i" in
172
				*::*) i=${i%%::*};;
173
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
174
			esac
175 176
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
177 178 179 180 181 182 183 184 185 186

			# verify that our source does not have git tag version
			# name as tarball (typicallly github)
			if is_remote "$i" && [ "${i#*::}" = "$i" ]; then
				case ${i##*/} in
				v$pkgver.tar.*|$pkgver.tar.*)
					die "source ${i##*/} needs to be renamed to avoid possible collisions"
					;;
				esac
			fi
187 188
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
189

190 191 192 193 194 195 196 197
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
198
		done
199
	done
200

201
	# common spelling errors
202 203 204 205 206
	[ -n "$depend" ] && spell_error depend depends
	[ -n "$makedepend" ] && spell_error makedepend makedepends
	[ -n "$pkguser" ] && spell_error pkguser pkgusers
	[ -n "$pkggroup" ] && spell_error pkggroup pkggroups
	[ -n "$subpackage" ] && spell_error subpackage subpackages
Natanael Copa's avatar
Natanael Copa committed
207

208
	check_maintainer || die "Provide a valid RFC822 maintainer address"
209

210 211
	check_depends_dev || warning "depends_dev found but no development subpackage found"

212
	makedepends_has 'g++' && warning "g++ should not be in makedepends"
213 214 215
	return 0
}

216 217 218 219
sanitycheck() {
	default_sanitycheck
}

220 221
sumcheck() {
	local algo="$1" sums="$2"
222
	local dummy f endreturnval originalparams origin file
223 224 225 226 227 228 229 230

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
231
	fi
232
	fetch || return 1
233
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
234
	cd "$srcdir" || return 1
235 236
	IFS=$'\n'
	endreturnval=0
237
	for src in $sums; do
238
		origin=$1; shift
239
		echo "$src" | ${algo}sum -c
240
		if [ $? -ne 0 ]; then
241
			endreturnval=1
242
			is_remote $origin || continue
243 244 245 246 247

			local csum="${src:0:8}"
			local file="$SRCDEST/$(filename_from_uri $origin)"

			echo "Because the remote file above failed the ${algo}sum check it will be renamed."
248
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
249 250
			echo "Renaming: ${file##*/} to ${file##*/}.$csum"
			mv "$file" "$file.$csum"
251 252 253 254
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
255 256
}

257 258 259 260 261 262 263 264 265
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
266
	for algo in sha512 sha256 sha1 md5; do
267 268 269 270 271 272 273
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
274
		break
275 276 277 278 279 280 281
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
282 283
# verify upstream sources
sourcecheck() {
284 285 286 287 288 289 290 291
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
292 293 294
		*::*)
			uri=${uri##*::}
			;;
295 296
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
297
	done
298
	return 0
Natanael Copa's avatar
Natanael Copa committed
299
}
300

Natanael Copa's avatar
Natanael Copa committed
301 302
uri_fetch() {
	local uri="$1"
303
	[ -n "$quiet" ] && opts="-s"
304

Natanael Copa's avatar
Natanael Copa committed
305
	mkdir -p "$SRCDEST"
306
	abuild-fetch -d "$SRCDEST" "$uri"
Natanael Copa's avatar
Natanael Copa committed
307 308
}

309
is_remote() {
310
	case "${1#*::}" in
311
		http://*|ftp://*|https://*|saveas-*://*)
312 313 314 315 316
			return 0;;
	esac
	return 1
}

317 318 319 320 321 322 323 324 325
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

326 327 328 329
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
330
		if is_remote "$DISTFILES_MIRROR"; then
331 332
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
333
		else
334 335
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
336
		fi
337 338 339 340
	fi
	uri_fetch "$uri"
}

341
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
342 343
	local s
	mkdir -p "$srcdir"
344 345
	for s in $source; do
		if is_remote "$s"; then
346
			uri_fetch_mirror "$s" || return 1
347
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
348
		else
349 350
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
351 352 353
	done
}

354 355 356 357
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
358 359
# verify that all init.d scripts are openrc runscripts
initdcheck() {
360
	local i line
Natanael Copa's avatar
Natanael Copa committed
361 362
	for i in $source; do
		case $i in
363 364 365 366 367 368 369 370 371 372 373
		*.initd) line=$(head -n 1 "$srcdir"/$i);;
		*) continue ;;
		esac

		case "$line" in
		*sbin/openrc-run)
			;;
		*sbin/runscript)
			warning "$i is not an openrc #!/sbin/openrc-run"
			;;
		*)	error "$i is not an openrc #!/sbin/openrc-run"
Natanael Copa's avatar
Natanael Copa committed
374 375 376
			return 1
			;;
		esac
377
	done
Natanael Copa's avatar
Natanael Copa committed
378 379
}

Natanael Copa's avatar
Natanael Copa committed
380
# unpack the sources
381
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
382
	local u
383
	if [ -z "$force" ]; then
384
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
385
		initdcheck || return 1
386
	fi
Natanael Copa's avatar
Natanael Copa committed
387 388
	mkdir -p "$srcdir"
	for u in $source; do
389
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
390
		case "$s" in
391 392 393
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
394
			*.tar.gz|*.tgz)
395
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
396 397
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
398
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
399
				tar -C "$srcdir" -jxf "$s" || return 1;;
400 401 402 403
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
404 405 406
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
407 408
			*.zip)
				msg "Unpacking $s..."
409
				unzip -q "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
410 411 412 413
		esac
	done
}

414 415 416 417
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
418 419
# cleanup source and package dir
clean() {
420
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
421
	rm -rf "$srcdir"
422
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
423 424 425 426 427 428
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
429
		if is_remote "$s"; then
430 431 432
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
433
		fi
Natanael Copa's avatar
Natanael Copa committed
434 435 436
	done
}

437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458
subpkg_unset() {
	unset subpkgname subpkgsplit subpkgarch
}

subpkg_set() {
	subpkgname=${1%%:*}

	local _splitarch=${1#*:}
	[ "$_splitarch" = "$1" ] && _splitarch=""

	subpkgsplit=${_splitarch%%:*}
	[ -z "$subpkgsplit" ] && subpkgsplit="${subpkgname##*-}"

	subpkgarch=${_splitarch#*:}
	if [ "$subpkgarch" = "$_splitarch" -o -z "$subpkgarch" ]; then
		case "$subpkgname" in
		*-doc | *-lang | *-lang-*) subpkgarch="noarch" ;;
		*) subpkgarch="$pkgarch" ;;
		esac
	fi
}

Natanael Copa's avatar
Natanael Copa committed
459 460
cleanpkg() {
	local i
461
	getpkgver || return 1
462
	msg "Cleaning built packages..."
463 464 465 466
	rm -f "$REPODEST/$repo/src/$pkgname-$pkgver-r$pkgrel.src.tar.gz"
	for i in $allpackages; do
		subpkg_set "$i"
		rm -f "$REPODEST/$repo/$subpkgarch/$subpkgname-$pkgver-r$pkgrel.apk"
Natanael Copa's avatar
Natanael Copa committed
467
	done
468 469
	subpkg_unset

470
	# remove given packages from index
471
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
472 473
}

474 475 476
# clean all packages except current
cleanoldpkg() {
	local i j
477
	getpkgver || return 1
478
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
479 480 481 482
	for i in $allpackages; do
		subpkg_set "$i"
		for j in "$REPODEST"/$repo/*/$subpkgname-[0-9]*.apk ; do
			[ "${j##*/}" = "$subpkgname-$pkgver-r$pkgrel.apk" ] \
483
				&& continue
484
			rm -f "$j"
485 486
		done
	done
487
	subpkg_unset
488
	update_abuildrepo_index
489 490
	return 0
}
491 492 493

mkusers() {
	local i
494 495 496 497 498 499
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
500 501
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
502
			local gopt=
503
			msg "Creating user $i"
504 505 506
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
507
			$ADDUSER -S -D -H $gopt $i || return 1
508 509 510 511
		fi
	done
}

Natanael Copa's avatar
Natanael Copa committed
512 513
# helper to update config.sub to a recent version
update_config_sub() {
514
	local changed=false
Natanael Copa's avatar
Natanael Copa committed
515
	find . -name config.sub | while read f; do
516 517
		if ! ./$f armv6-alpine-linux-muslgnueabihf 2>/dev/null; then
			msg "Updating $f"
518 519 520
			cp "$datadir"/${f##*/} "$f" || return 1
			changed=true
		else
521
			msg "No update needed for $f"
522 523 524
		fi
		# pipe subshell will return status of last command
		$changed
Natanael Copa's avatar
Natanael Copa committed
525
	done
526
	return $?
Natanael Copa's avatar
Natanael Copa committed
527
}
528

Natanael Copa's avatar
Natanael Copa committed
529 530
runpart() {
	local part=$1
531
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
532 533 534 535
	$part || die "$part failed"
}

# override those in your build script
536 537 538 539 540 541 542 543
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

544 545 546 547 548 549 550 551 552 553
have_patches() {
	local i
	for i in $source; do
		case "$i" in
			*.patch) return 0;;
		esac
	done
	return 1
}

554 555
default_prepare() {
	local i
556 557 558
	if ! have_patches; then
		return 0
	fi
559 560
	cd "${builddir:-$srcdir/$pkgname-$pkgver}" \
		|| { error "Is \$builddir set correctly?"; return 1; }
561 562 563 564
	for i in $source; do
		case $i in
			*.patch)
				msg "$i"
565
				patch "${patch_args:--p1}" -i "$srcdir/$i" || return 1
566 567 568 569 570
				;;
		esac
	done
}

Natanael Copa's avatar
Natanael Copa committed
571
prepare() {
572
	default_prepare
Natanael Copa's avatar
Natanael Copa committed
573 574
}

Natanael Copa's avatar
Natanael Copa committed
575
build() {
576
	:
Natanael Copa's avatar
Natanael Copa committed
577 578
}

579 580 581
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
582 583
	mkdir -p "$REPODEST"/src
	tar -czf "$REPODEST"/src/$pkgname-$pkgver-r$pkgrel.tar.gz *
584 585
}

586 587 588
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
589
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
590 591 592 593 594 595 596
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
597 598 599 600
		if [ -d "$dir"/usr/var ]; then
			error "Found /usr/var, localstatedir is most likely wrong"
			return 1
		fi
Natanael Copa's avatar
Natanael Copa committed
601
	fi
602 603 604 605

	# remove *.la files if libtool is not set
	if ! options_has "libtool"; then
		find "$dir" -name '*.la' -type f -delete
606
	fi
607

608 609 610 611 612 613
	# look for /usr/lib/charset.alias
	if [ -e "$dir"/usr/lib/charset.alias ] \
			&& ! options_has "charset.alias"; then
		error "Found /usr/lib/charset.alias"
		return 1
	fi
614 615
	# look for /usr/share/doc
	if [ -e "$dir"/usr/share/doc ] \
616
			&& ! is_doc_pkg "$name"; then
617 618 619
		warning "Found /usr/share/doc but package name doesn't end with -doc"
	fi
	# look for /usr/share/man
620
	if [ -e "$dir"/usr/share/man ]; then
621
		if ! is_doc_pkg "$name"; then
622 623
			warning "Found /usr/share/man but package name doesn't end with -doc"
		fi
624
		# check for uncompressed man pages
625
		i=$(find "$dir"/usr/share/man -name '*.[0-8]' -type f | sed "s|^$dir|\t|")
626 627 628 629 630 631
		if [ -n "$i" ]; then
			error "Found uncompressed man pages:"
			echo "$i"
			return 1
		fi
	fi
632 633 634 635 636 637
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
638
	# check so we dont have any suid root binaries that are not PIE
639
	i=$(find "$dir" -type f -perm /6000 \
640 641 642 643 644 645 646
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
647 648 649 650 651 652 653 654 655 656 657
	# test suid bit on executable
	if ! options_has "suid"; then
		i=$(find "$dir" \( -perm -u+s -o -perm -g+s \) -a -type f \
			-a -perm -o+x)
		if [ -n "$i" ]; then
			error "Found executable files with SUID bit set:"
			echo "$i"
			return 1
		fi
	fi

Natanael Copa's avatar
Natanael Copa committed
658 659 660 661 662 663 664 665 666
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
667 668 669
	return 0
}

670 671 672 673 674 675 676 677 678
pre_split() {
	if [ -z "$subpkgname" ]; then
		return 0
	fi
	# the subpackages should not inherit those form main package
	provides=""
	install_if=""
}

679
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
680 681
	local i
	cd "$startdir"
682
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
683
		# call abuild recursively, setting subpkg{dir,name}
684 685 686 687
		( subpkg_set "$i"; msg "Running split function $subpkgsplit..."; \
		  subpkgdir="$pkgbasedir/$subpkgname" subpkgname="$subpkgname" subpkgarch="$subpkgarch" \
		  $0 pre_split $subpkgsplit prepare_package \
			&& postcheck "$pkgbasedir/$subpkgname" "$subpkgname" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
688
	done
689
	postcheck "$pkgdir" "$pkgname" || return 1
690 691
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
692
		warning "Found /usr/share/locale"
693
		warning2 "Maybe add \$pkgname-lang to subpackages?"
694
	fi
Natanael Copa's avatar
Natanael Copa committed
695 696
}

697
default_lang() {
698
	pkgdesc="Languages for package $pkgname"
699
	install_if="$pkgname=$pkgver-r$pkgrel lang"
700

701 702 703 704 705 706 707 708 709 710 711
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

712
default_lang_subpkg() {
713 714 715 716
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
717
	pkgdesc="$pkgname language pack for $lang"
718
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
719

720 721 722 723 724
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
725
		|| return 1
726 727 728 729 730
	done
}

lang_subpkg() {
	default_lang_subpkg
731 732 733
}

prepare_language_packs() {
734
	local lang
735 736 737 738 739 740 741 742
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

743 744 745 746 747 748 749 750 751 752 753 754
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

755 756 757
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
758 759
		# remove surrounding whitespace
		maintainer=$(echo "$maintainer" | xargs)
760 761 762
	fi
}

763 764


765 766 767 768 769 770 771 772 773 774
check_maintainer() {
	get_maintainer
	if [ -z "$maintainer" ]; then
		warning "No maintainer"
	else
		# try to check for a valid rfc822 address
		case "$maintainer" in
			*[A-Za-z0-9]*\ \<*@*.*\>) ;;
			*) return 1 ;;
		esac
775 776 777
	fi
}

778
check_depends_dev() {
Natanael Copa's avatar
Natanael Copa committed
779 780
	if [ -z "$depends_dev" ]; then
		return 0
781
	fi
Natanael Copa's avatar
Natanael Copa committed
782 783
	local i
	for i in $pkgname $subpackages; do
784 785
		case "${i%%:*}" in
		*-dev) return 0 ;;
Natanael Copa's avatar
Natanael Copa committed
786 787 788
		esac
	done
	return 1
789 790
}

791
prepare_metafiles() {
792
	getpkgver || return 1
793 794
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
795
	local dir=${subpkgdir:-$pkgdir}
796
	local pkg="$name-$pkgver-r$pkgrel.apk"
797
	local pkginfo="$controldir"/.PKGINFO
798
	local sub
799

Natanael Copa's avatar
Natanael Copa committed
800 801
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
802
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
803 804 805
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

806 807 808 809 810
	if [ "$arch" != "$apkbuild_arch" ]; then
		local msg="Split function set arch=\"$arch\" for $name, use subpackages=pkg:split:arch format instead"
		[ "$arch" != "noarch" ] && die "$msg"
		warning "$msg"
		subpkgarch="$arch"
811 812
	fi

813
	echo "# Generated by $(basename $0) $program_version" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
814
	if [ -n "$FAKEROOTKEY" ]; then
815
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
816
	fi
817 818
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
819
pkgname = $name
820
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
821 822 823 824 825
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
826
arch = ${subpkgarch:-$pkgarch}
Natanael Copa's avatar
Natanael Copa committed
827
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
828
EOF
829 830
	local i deps
	deps="$depends"
Leslie Polzer's avatar
Leslie Polzer committed
831
	if [ "$pkgname" != "busybox" ] && ! depends_has busybox; then
832 833
		for i in $install $triggers; do
			local s=${i%=*}
834
			[ "$name" != "${s%.*}" ] && continue
835
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
836 837 838 839 840
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
841
	fi
842

843 844 845
	# store last_commit in global var so we only call git once
	if [ -z "$last_commit" ]; then
		last_commit="$(git_last_commit)$(git_dirty)"
846
	fi
847
	echo "commit = $last_commit" >> "$pkginfo"
848

849
	get_maintainer
850 851 852 853
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

854
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
855
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
856 857
	fi

Natanael Copa's avatar
Natanael Copa committed
858
	echo "license = $license" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
859
	for i in $replaces; do
860
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
861
	done
862
	for i in $deps; do
863
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
864 865
	done
	for i in $provides; do
866
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
867
	done
868 869 870 871 872 873
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
874 875 876
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
877 878

	local metafiles=".PKGINFO"
879 880 881
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
882
		if [ "$n" != "$name" ]; then
883 884
			continue
		fi
885
		script=${f#$name}
886
		msg "Adding $script"
887
		cp "$startdir/$f" "$controldir/$script" || return 1
888
		chmod +x "$controldir/$script"
889 890
		metafiles="$metafiles $script"
	done
891
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
892
}
893

894
prepare_trace_rpaths() {
895
	local dir=${subpkgdir:-$pkgdir}
896
	local etype= soname= file= sover=
897
	[ "${subpkgarch:-$pkgarch}" = "noarch" ] && return 0
898
	options_has "!tracedeps" && return 0
899
	# lets tell all the places we should look for .so files - all rpaths
900 901
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
902
		>"$controldir"/.rpaths
903
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
904
		warning "Redundant /usr/lib in rpath found"
905 906 907 908 909
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
910 911
}

912 913
# search for broken symlinks so we later can pull in proper depends
prepare_symlinks() {
914
	local target
915 916 917 918
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	find -type l | while read symlink; do
919 920 921
		target=$(readlink "$symlink")
		if ! [ -e "$dir$(normalize_target_path "$target" "$symlink")" ]; then
			echo "$symlink $target" >> "$controldir"/.symlinks
922 923 924 925
		fi
	done
}

926 927 928 929 930 931 932 933 934 935
prepare_pkgconfig_provides() {
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	for i in usr/lib/pkgconfig/*.pc; do
		if ! [ -e "$i" ]; then
			continue
		fi
		local f=${i##*/}
		local v=$(PKG_CONFIG_PATH="$dir"/usr/lib/pkgconfig pkg-config \
936
			--modversion ${f%.pc})
937 938 939 940
		echo "${f%.pc}=${v:-0}" >> "$controldir"/.provides-pc
	done
}

941 942 943 944 945 946 947 948 949 950 951 952
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

953 954 955 956 957
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

958 959
# returns true if this is the -doc package
is_doc_pkg() {
960
	test "${1%-doc}" != "$1"
961 962
}

963 964 965 966
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
967
		[ "${subpkgarch:-$pkgarch}" != "noarch" ] && return 0
968 969
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
970
	elif [ "${subpkgarch:-$pkgarch}" != "noarch" ] && ! is_dev_pkg; then
971 972
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
973 974 975 976
	fi
	return 0
}

977
prepare_package() {
978
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
979
	stripbin
980 981 982 983
	prepare_metafiles \
		&& prepare_trace_rpaths \
		&& prepare_symlinks \
		&& prepare_pkgconfig_provides \
984
		|| return 1
985
	archcheck
986 987 988 989 990 991 992 993
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

994 995 996 997 998 999 1000 1001 1002 1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

1017 1018 1019 1020 1021
subpkg_provides_prefixed_so() {
	[ -n "$sonameprefix" ] && grep -q -w "^$sonameprefix$1" \
		"$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

1022
subpkg_provides_so() {
1023 1024 1025
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

1026
subpkg_provides_pc() {
1027 1028
	grep -q -w "^${1%%[<>=]*}" "$pkgbasedir"/.control.*/.provides-pc \
		2>/dev/null
1029 1030
}

1031 1032 1033
trace_apk_deps() {
	local name="$1"
	local dir="$2"
1034
	local i= found= autodeps= deppkgs= missing=
1035

1036
	msg "Tracing dependencies..."
1037 1038 1039
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
1040 1041 1042 1043
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
1044 1045
	if [ "$CLIBC" = "uclibc" ] && [ -f "$dir"/.needs-so ] \
			&& grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
1046 1047
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
1048
		msg "  added libgcc (due to libpthread)"
1049
	fi
1050

1051
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
1052
		# first check if its provided by same apkbuild
1053
		grep -q -w "^$sonameprefix$i" "$dir"/.provides-so 2>/dev/null && continue
1054

1055 1056 1057
		if subpkg_provides_prefixed_so "$i"; then
			autodeps="$autodeps so:$sonameprefix$i"
		elif subpkg_provides_so "$i" || cross_compiling \
1058
				|| $APK info --quiet --installed "so:$i"; then
1059
			autodeps="$autodeps so:$i"
1060
		else
1061
			missing="$missing $i"
1062
		fi
1063 1064 1065
	done

	# find all packages that holds the so files
1066
	if [ -f "$dir"/.rpaths ]; then
1067 1068
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
1069
		deppkgs=$($APK info --quiet --who-owns $so_files) || return 1
1070 1071
	fi

1072
	for found in $deppkgs; do
1073
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
1074 1075 1076
			warning "You can remove '$found' from depends"
			continue
		fi
1077
		autodeps="$autodeps $found"
1078
	done
1079

1080 1081 1082 1083 1084
	# symlink targets
	for i in $(sort -u "$dir"/.symlinks-needs 2>/dev/null); do
		autodeps="$autodeps $i"
	done

1085 1086 1087 1088
	# pkg-config depends
	for i in $(sort -u "$dir"/.needs-pc 2>/dev/null); do
		if subpkg_provides_pc "$i" || cross_compiling \
				|| $APK info --quiet --installed "pc:$i"; then
1089 1090 1091 1092
			local provider=$(apk search --quiet "pc:$i")
			if list_has "$provider" $depends_dev; then
				warning "$provider should be removed from depends_dev"
			fi
1093
			autodeps="$autodeps pc:$i"
1094 1095 1096 1097 1098 1099 1100
		else
			warning "Could not find any provider for pc:$i"
			local pcfile=/usr/lib/pkgconfig/"${i%%[<>=]*}".pc
			if [ -e "$pcfile" ]; then
				local owner=$($APK info --quiet --who-owns $pcfile)
				warning "${owner:-package providing $pcfile} needs to be rebuilt"
			fi
1101 1102 1103
		fi
	done

1104
	echo "# automatically detected:" >> "$dir"/.PKGINFO
1105
	if [ -f "$dir"/.provides-so ]; then